<template>
  <div>
    <h1>Add Appointment</h1>
    <div class="mb-3">
      <Datepicker v-model="date" />
    </div>

    <div class="mb-3">
      <select class="form-control" v-model="contactId">
        <option disabled value="0">Choose contact</option>
        <option
          v-for="(contact, index) in contacts"
          :key="index"
          :value="contact.id"
        >
          {{
            contact.fields.contact_name + " " + contact.fields.contact_surname
          }}
        </option>
      </select>
    </div>
    <div class="mb-3">
      <select class="form-control" v-model="agentId">
        <option disabled value="0">Choose agent</option>
        <option v-for="(agent, index) in agents" :key="index" :value="agent.id">
          {{ agent.fields.agent_name + " " + agent.fields.agent_surname }}
        </option>
      </select>
    </div>
    <div class="mb-3">
      <input
        type="text"
        readonly
        class="form-control"
        v-model="postCode"
        placeholder="Post code"
      />
    </div>
    <div class="mb-3">
      <Map />
    </div>
    <div class="mb-3">
      <button
        type="submit"
        @click="create"
        class="btn form-control btn-success btn-full"
      >
        Create
      </button>
    </div>
  </div>
</template>

<script>
import axios from "axios";
import Datepicker from "vue3-date-time-picker";
import Map from "@/components/Map";
import "vue3-date-time-picker/dist/main.css";

const AGENTS_URL = "https://api.airtable.com/v0/appgykZBGTF92MnHu/Agents";
const CONTACTS_URL = "https://api.airtable.com/v0/appgykZBGTF92MnHu/Contacts";
const APPOINTMENT_URL =
  "https://api.airtable.com/v0/appgykZBGTF92MnHu/Appointments";

export default {
  data() {
    return {
      agents: [],
      agentId: 0,
      contacts: [],
      contactId: 0,
      date: new Date(),
      postCode: "",
    };
  },
  components: { Datepicker, Map },
  mounted() {
    axios
      .get(AGENTS_URL, {
        headers: {
          Authorization: "Bearer keyYIULY6l1seh10Q",
        },
      })
      .then((res) => (this.agents = res.data.records))
      .catch((err) => console.log(err));
    axios
      .get(CONTACTS_URL, {
        headers: {
          Authorization: "Bearer keyYIULY6l1seh10Q",
        },
      })
      .then((res) => (this.contacts = res.data.records))
      .catch((err) => console.log(err));
  },
  methods: {
    create() {
      if (this.contactId == 0) {
        alert("Please select a contact");
        return;
      }

      if (this.agentId == 0) {
        alert("Please select a agent");
        return;
      }

      var obj = {
        fields: {
          appointment_date: this.date,
          appointment_postcode: "CM2 6NH",
          contact_id: [this.contactId],
          agent_id: [this.agentId],
        },
      };

      axios
        .post(APPOINTMENT_URL, obj, {
          headers: {
            Authorization: "Bearer keyYIULY6l1seh10Q",
            "Content-Type": "application/json",
          },
        })
        .then((r) => alert("Record success"))
        .catch((e) => alert(e));
    },
    getAgents: () => {
      axios
        .get(API_URL, {
          headers: {
            Authorization: "Bearer keyYIULY6l1seh10Q",
          },
        })
        .then((res) => (this.agents = res.data))
        .catch((err) => console.log(err));
    },
  },
};
</script>

<style></style>
